<template>
  <single-pane :capt="dictionaryRu.title" class="locationTypesGrid">
    <ob-table
      :columns="columnsObTable"
      :functional-panel="true"
      :remote-opt="getObTableData"
      @select="onSelection"
      ref="obTable"
      is-fixed-header
    />
    <ob-modal
      ref="viewItem"
      :title="dictionaryRu.modal.title"
      custom-class="modal-medium"
      :is-read-only="true"
      :is-show-pagination="true"
      @onRefresh="onRefresh"
    >
      <modal
        v-if="selectedData.uuid"
        :selected-data="selectedData"
        :api="api"
        @refresh="onRefresh"
      />
    </ob-modal>
  </single-pane>
</template>

<script>
  import SinglePane from 'common-components/src/obComponents/obSinglePanels'
  import { getIconByLocation } from '@/helpers'
  import paging from '@/mixins/dictionaries/paging';
  import itemMixin from '@/mixins/dictionaries/edit-item';
  import userAccessMixin from '@/mixins/user-access-mixin'
  import ObModal from 'common-components/src/obComponents/obModal'
  import ObTable from 'common-components/src/obComponents/obTable'
  import Modal from './modal'
  import { dictionaryDefault } from '@/translations/ru/default'
  import { dictionary } from '@/translations/ru/dictionaries__locations__location_types';

  export default {
    name: 'LocationTypes',
    components: {
      ObModal,
      ObTable,
      SinglePane,
      Modal
    },
    mixins: [
      itemMixin,
      paging,
      userAccessMixin
    ],
    data() {
      return {
        dictionaryRu: Object.assign(dictionary, dictionaryDefault),
        dataGridRefName: 'LocationTypes',
        api: {
          source: '/oboz2-dictionary-location-types-viewer/v1/',
        },
        userAccessMap: {
          CRUD: ['dictionary__location_types__list_read'],
          CREATE: ['dictionary__location_types__details_create'],
          VIEW: ['dictionary__location_types__details_read'],
          UPDATE: ['dictionary__location_types__details_update'],
          DELETE: ['dictionary__location_types__details_delete']
        }
      }
    },
    computed: {
      columnsObTable () {
        return [
          {
            title: this.dictionaryRu.columns.name,
            key: 'name',
            html: function (data) {
              return `<div class="location-title">
                  <i class="icon location-title__icon ${getIconByLocation(data.uuid)}"></i>
                  <span class="location-title__text">${data.name}</span>
              </div>`
            }
          },
          {
            title: this.dictionaryRu.columns.infrastructure_facility,
            key: 'infrastructure_facility',
            html: (data) => {
              return data.infrastructure_facility ? this.dictionaryRu.columns.infrastructure_facility_yes : this.dictionaryRu.columns.infrastructure_facility_no
            }
          },
          {
            title: this.dictionaryRu.columns.data_completion,
            key: 'data_completion',
          },
          {
            title: this.dictionaryRu.columns.status,
            key: 'is_active',
            allowSorting: false,
            html: (data) => {
              return !data.is_active ? this.dictionaryRu.status.inactive : this.dictionaryRu.status.active
            }
          },
        ]
      }
    }
  }
</script>

<style lang="scss">
  @import '~common-components/src/static/css/variables.scss';

  .locationTypesGrid {
    .location-title {
      display: flex;
      align-items: center;
      &__icon {
        display: flex;
        align-items: center;
        color: $color-blue-navy-blue;
        font-size: 16px;
        width: 16px;
      }
      &__text {
        padding-left: 10px;
      }
    }
  }
</style>
